package ast;
public class STATS extends AST {
   public STATEMENT left;           // Child
   public STATS right;          // Child

   public sym.ProcedureSy currentProc;    // Synthesized. The current procedure.
   public sym.Env env;            // Inherited Attribute. The environment.
   public sym.Label _true;           // Inherited           
   public sym.Label _false;          // Inherited           
   public sym.Label parentNext;     // Inherited           
   public sym.Label label;          // Synthesized           
   public sym.Label begin;          // Synthesized
   public boolean isInLoop;       // Synthesized
   public sym.Label currentLoopExit;// Synthesized
   public sym.SyTab declsIn;        // Inherited. The symbol table built so far.
   public sym.SyTab declsOut;       // Synthesized. The completed symbol table.
   public int offsetIn;       // Inherited. The local variable offset so far.
   public int offsetOut;      // Synthesized. The total local variable size.
   public sym.Label next;            // Synthesized

   public STATS (int position) {
       super(position);
       this.label = new sym.Label();
   }

   public STATS (STATEMENT left, STATS right, int position) {
       super(position);
       this.left = left;
       this.right = right;
       this.label = new sym.Label();
   }

   public String toString(int indent) {
       String s = blanks(indent) + 
                  "<STATS " + 
                  "pos=\"" + position + "\">\n";
       s += left.toString(indent+1);
       s += right.toString(indent+1);
       s += blanks(indent) + "</STATS>\n";
       return s;
   }
}

